# robustsp

This package contains the functions that are currently available in the RobustSP toolbox: a Matlab toolbox for robust signal processing [[1]](https://github.com/RobustSP/toolbox) in Python. The toolbox can be freely used for non-commercial use only. Please make appropriate references to the book:

Zoubir, A. M., Koivunen, V., Ollila, E., and Muma, M. Robust Statistics for Signal Processing Cambridge University Press, 2018.

[1] https://github.com/RobustSP/toolbox

## Dependencies

* Python 3
* numpy
* matplotlib
* scipy
* statsmodels

## Installation

There are two ways to install this package

### Installation version 1

Just run the following line in the command line:

    pip install robustsp
### Installation version 2

If you would like to have the source files of the package easily accessible.

1. Download the files.
2. Unzip the files where you want them (if you downloaded the repo as a zip file)
3. Open a command window in the freshly unzipped folder (should be called robustsp-master or something like that and contain setup.py)
4. Run in in the command window: ```pip install -e .```
    (Don't forget the dot)

## Examples

[Portfolio with examples for each chapter on google colab](https://colab.research.google.com/drive/1dMz4MXhwz6eKbx-hfbaMduUvqIipNSPB)

